#include <cstdlib>
#include "TradBlinnPhongGlobal.h"
#include "DeferBlinnPhongLocal.h"
#include "DeferBlinnPhongSpot.h"
#include "DeferPhongGlobal.h"
#include "DeferCookTorranceGlobal.h"
#include "DeferGoochGlobal.h"
#include "DeferBlinnPhongGlobal.h"


DeferBlinnPhongGlobal* DeferBlinnPhongGlobal::singleton = NULL;


//getInstance
DeferBlinnPhongGlobal* DeferBlinnPhongGlobal::getInstance(Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new DeferBlinnPhongGlobal(geoLights, "Source/ShaderPrograms/DeferredShading/gp_FullScreenQuad.cg", "Source/ShaderPrograms/DeferredShading/fp_BlinnPhongGlobal.cg", "Deferred shading with Blinn-Phong illumination and point lights with global influence");
    return singleton;
}


//getPointer
DeferBlinnPhongGlobal* DeferBlinnPhongGlobal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* DeferBlinnPhongGlobal::enableTraditional() {
    return TradBlinnPhongGlobal::getPointer();
}
ShadingState* DeferBlinnPhongGlobal::enableDeferred() {
    return singleton;
}
ShadingState* DeferBlinnPhongGlobal::enableLocal() {
    return DeferBlinnPhongLocal::getPointer();
}
ShadingState* DeferBlinnPhongGlobal::enableSpot() {
    return DeferBlinnPhongSpot::getPointer();
}
ShadingState* DeferBlinnPhongGlobal::enableGlobal() {
    return singleton;
}
ShadingState* DeferBlinnPhongGlobal::enablePhong() {
    return DeferPhongGlobal::getPointer();
}
ShadingState* DeferBlinnPhongGlobal::enableBlinnPhong() {
    return singleton;
}
ShadingState* DeferBlinnPhongGlobal::enableCookTorrance() {
    return DeferCookTorranceGlobal::getPointer();
}
ShadingState* DeferBlinnPhongGlobal::enableGooch() {
    return DeferGoochGlobal::getPointer();
}
