#include <cstdlib>
#include "TradBlinnPhongLocal.h"
#include "DeferBlinnPhongSpot.h"
#include "DeferBlinnPhongGlobal.h"
#include "DeferPhongLocal.h"
#include "DeferCookTorranceLocal.h"
#include "DeferGoochLocal.h"
#include "DeferBlinnPhongLocal.h"


DeferBlinnPhongLocal* DeferBlinnPhongLocal::singleton = NULL;


//getInstance
DeferBlinnPhongLocal* DeferBlinnPhongLocal::getInstance(Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new DeferBlinnPhongLocal(geoLights, "Source/ShaderPrograms/DeferredShading/gp_Billboard.cg", "Source/ShaderPrograms/DeferredShading/fp_BlinnPhongLocal.cg", "Deferred shading with Blinn-Phong illumination and point lights with local influence");
    return singleton;
}


//getPointer
DeferBlinnPhongLocal* DeferBlinnPhongLocal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* DeferBlinnPhongLocal::enableTraditional() {
    return TradBlinnPhongLocal::getPointer();
}
ShadingState* DeferBlinnPhongLocal::enableDeferred() {
    return singleton;
}
ShadingState* DeferBlinnPhongLocal::enableLocal() {
    return singleton;
}
ShadingState* DeferBlinnPhongLocal::enableSpot() {
    return DeferBlinnPhongSpot::getPointer();
}
ShadingState* DeferBlinnPhongLocal::enableGlobal() {
    return DeferBlinnPhongGlobal::getPointer();
}
ShadingState* DeferBlinnPhongLocal::enablePhong() {
    return DeferPhongLocal::getPointer();
}
ShadingState* DeferBlinnPhongLocal::enableBlinnPhong() {
    return singleton;
}
ShadingState* DeferBlinnPhongLocal::enableCookTorrance() {
    return DeferCookTorranceLocal::getPointer();
}
ShadingState* DeferBlinnPhongLocal::enableGooch() {
    return DeferGoochLocal::getPointer();
}
