#include <cstdlib>
#include "TradBlinnPhongSpot.h"
#include "DeferBlinnPhongLocal.h"
#include "DeferBlinnPhongGlobal.h"
#include "DeferPhongSpot.h"
#include "DeferCookTorranceSpot.h"
#include "DeferGoochSpot.h"
#include "DeferBlinnPhongSpot.h"


DeferBlinnPhongSpot* DeferBlinnPhongSpot::singleton = NULL;


//getInstance
DeferBlinnPhongSpot* DeferBlinnPhongSpot::getInstance(Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new DeferBlinnPhongSpot(geoLights, "Source/ShaderPrograms/DeferredShading/gp_Pyramid.cg", "Source/ShaderPrograms/DeferredShading/fp_BlinnPhongSpot.cg", "Deferred shading with Blinn-Phong illumination and spot lights");
    return singleton;
}


//getPointer
DeferBlinnPhongSpot* DeferBlinnPhongSpot::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* DeferBlinnPhongSpot::enableTraditional() {
    return TradBlinnPhongSpot::getPointer();
}
ShadingState* DeferBlinnPhongSpot::enableDeferred() {
    return singleton;
}
ShadingState* DeferBlinnPhongSpot::enableLocal() {
    return DeferBlinnPhongLocal::getPointer();
}
ShadingState* DeferBlinnPhongSpot::enableSpot() {
    return singleton;
}
ShadingState* DeferBlinnPhongSpot::enableGlobal() {
    return DeferBlinnPhongGlobal::getPointer();
}
ShadingState* DeferBlinnPhongSpot::enablePhong() {
    return DeferPhongSpot::getPointer();
}
ShadingState* DeferBlinnPhongSpot::enableBlinnPhong() {
    return singleton;
}
ShadingState* DeferBlinnPhongSpot::enableCookTorrance() {
    return DeferCookTorranceSpot::getPointer();
}
ShadingState* DeferBlinnPhongSpot::enableGooch() {
    return DeferGoochSpot::getPointer();
}
