#include <cstdlib>
#include "TradCookTorranceGlobal.h"
#include "DeferCookTorranceLocal.h"
#include "DeferCookTorranceSpot.h"
#include "DeferPhongGlobal.h"
#include "DeferBlinnPhongGlobal.h"
#include "DeferGoochGlobal.h"
#include "DeferCookTorranceGlobal.h"


DeferCookTorranceGlobal* DeferCookTorranceGlobal::singleton = NULL;


//getInstance
DeferCookTorranceGlobal* DeferCookTorranceGlobal::getInstance(Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new DeferCookTorranceGlobal(geoLights, "Source/ShaderPrograms/DeferredShading/gp_FullScreenQuad.cg", "Source/ShaderPrograms/DeferredShading/fp_CookTorranceGlobal.cg", "Deferred shading with Cook-Torrance illumination and point lights with global influence");
    return singleton;
}


//getPointer
DeferCookTorranceGlobal* DeferCookTorranceGlobal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* DeferCookTorranceGlobal::enableTraditional() {
    return TradCookTorranceGlobal::getPointer();
}
ShadingState* DeferCookTorranceGlobal::enableDeferred() {
    return singleton;
}
ShadingState* DeferCookTorranceGlobal::enableLocal() {
    return DeferCookTorranceLocal::getPointer();
}
ShadingState* DeferCookTorranceGlobal::enableSpot() {
    return DeferCookTorranceSpot::getPointer();
}
ShadingState* DeferCookTorranceGlobal::enableGlobal() {
    return singleton;
}
ShadingState* DeferCookTorranceGlobal::enablePhong() {
    return DeferPhongGlobal::getPointer();
}
ShadingState* DeferCookTorranceGlobal::enableBlinnPhong() {
    return DeferBlinnPhongGlobal::getPointer();
}
ShadingState* DeferCookTorranceGlobal::enableCookTorrance() {
    return singleton;
}
ShadingState* DeferCookTorranceGlobal::enableGooch() {
    return DeferGoochGlobal::getPointer();
}
