#include <cstdlib>
#include "TradCookTorranceLocal.h"
#include "DeferCookTorranceSpot.h"
#include "DeferCookTorranceGlobal.h"
#include "DeferPhongLocal.h"
#include "DeferBlinnPhongLocal.h"
#include "DeferGoochLocal.h"
#include "DeferCookTorranceLocal.h"


DeferCookTorranceLocal* DeferCookTorranceLocal::singleton = NULL;


//getInstance
DeferCookTorranceLocal* DeferCookTorranceLocal::getInstance(Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new DeferCookTorranceLocal(geoLights, "Source/ShaderPrograms/DeferredShading/gp_Billboard.cg", "Source/ShaderPrograms/DeferredShading/fp_CookTorranceLocal.cg", "Deferred shading with Cook-Torrance illumination and point lights with local influence");
    return singleton;
}


//getPointer
DeferCookTorranceLocal* DeferCookTorranceLocal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* DeferCookTorranceLocal::enableTraditional() {
    return TradCookTorranceLocal::getPointer();
}
ShadingState* DeferCookTorranceLocal::enableDeferred() {
    return singleton;
}
ShadingState* DeferCookTorranceLocal::enableLocal() {
    return singleton;
}
ShadingState* DeferCookTorranceLocal::enableSpot() {
    return DeferCookTorranceSpot::getPointer();
}
ShadingState* DeferCookTorranceLocal::enableGlobal() {
    return DeferCookTorranceGlobal::getPointer();
}
ShadingState* DeferCookTorranceLocal::enablePhong() {
    return DeferPhongLocal::getPointer();
}
ShadingState* DeferCookTorranceLocal::enableBlinnPhong() {
    return DeferBlinnPhongLocal::getPointer();
}
ShadingState* DeferCookTorranceLocal::enableCookTorrance() {
    return singleton;
}
ShadingState* DeferCookTorranceLocal::enableGooch() {
    return DeferGoochLocal::getPointer();
}
