#include <cstdlib>
#include "TradCookTorranceSpot.h"
#include "DeferCookTorranceLocal.h"
#include "DeferCookTorranceGlobal.h"
#include "DeferPhongSpot.h"
#include "DeferBlinnPhongSpot.h"
#include "DeferGoochSpot.h"
#include "DeferCookTorranceSpot.h"


DeferCookTorranceSpot* DeferCookTorranceSpot::singleton = NULL;


//getInstance
DeferCookTorranceSpot* DeferCookTorranceSpot::getInstance(Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new DeferCookTorranceSpot(geoLights, "Source/ShaderPrograms/DeferredShading/gp_Pyramid.cg", "Source/ShaderPrograms/DeferredShading/fp_CookTorranceSpot.cg", "Deferred shading with Cook-Torrance illumination and spot lights");
    return singleton;
}


//getPointer
DeferCookTorranceSpot* DeferCookTorranceSpot::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* DeferCookTorranceSpot::enableTraditional() {
    return TradCookTorranceSpot::getPointer();
}
ShadingState* DeferCookTorranceSpot::enableDeferred() {
    return singleton;
}
ShadingState* DeferCookTorranceSpot::enableLocal() {
    return DeferCookTorranceLocal::getPointer();
}
ShadingState* DeferCookTorranceSpot::enableSpot() {
    return singleton;
}
ShadingState* DeferCookTorranceSpot::enableGlobal() {
    return DeferCookTorranceGlobal::getPointer();
}
ShadingState* DeferCookTorranceSpot::enablePhong() {
    return DeferPhongSpot::getPointer();
}
ShadingState* DeferCookTorranceSpot::enableBlinnPhong() {
    return DeferBlinnPhongSpot::getPointer();
}
ShadingState* DeferCookTorranceSpot::enableCookTorrance() {
    return singleton;
}
ShadingState* DeferCookTorranceSpot::enableGooch() {
    return DeferGoochSpot::getPointer();
}
