#include <cstdlib>
#include "TradPhongGlobal.h"
#include "DeferPhongLocal.h"
#include "DeferPhongSpot.h"
#include "DeferBlinnPhongGlobal.h"
#include "DeferCookTorranceGlobal.h"
#include "DeferGoochGlobal.h"
#include "DeferPhongGlobal.h"


DeferPhongGlobal* DeferPhongGlobal::singleton = NULL;


//getInstance
DeferPhongGlobal* DeferPhongGlobal::getInstance(Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new DeferPhongGlobal(geoLights, "Source/ShaderPrograms/DeferredShading/gp_FullScreenQuad.cg", "Source/ShaderPrograms/DeferredShading/fp_PhongGlobal.cg", "Deferred shading with Phong illumination and point lights with global influence");
    return singleton;
}


//getPointer
DeferPhongGlobal* DeferPhongGlobal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* DeferPhongGlobal::enableTraditional() {
    return TradPhongGlobal::getPointer();
}
ShadingState* DeferPhongGlobal::enableDeferred() {
    return singleton;
}
ShadingState* DeferPhongGlobal::enableLocal() {
    return DeferPhongLocal::getPointer();
}
ShadingState* DeferPhongGlobal::enableSpot() {
    return DeferPhongSpot::getPointer();
}
ShadingState* DeferPhongGlobal::enableGlobal() {
    return singleton;
}
ShadingState* DeferPhongGlobal::enablePhong() {
    return singleton;
}
ShadingState* DeferPhongGlobal::enableBlinnPhong() {
    return DeferBlinnPhongGlobal::getPointer();
}
ShadingState* DeferPhongGlobal::enableCookTorrance() {
    return DeferCookTorranceGlobal::getPointer();
}
ShadingState* DeferPhongGlobal::enableGooch() {
    return DeferGoochGlobal::getPointer();
}
