#include <cstdlib>
#include "TradPhongLocal.h"
#include "DeferPhongSpot.h"
#include "DeferPhongGlobal.h"
#include "DeferBlinnPhongLocal.h"
#include "DeferCookTorranceLocal.h"
#include "DeferGoochLocal.h"
#include "DeferPhongLocal.h"


DeferPhongLocal* DeferPhongLocal::singleton = NULL;


//getInstance
DeferPhongLocal* DeferPhongLocal::getInstance(Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new DeferPhongLocal(geoLights, "Source/ShaderPrograms/DeferredShading/gp_Billboard.cg", "Source/ShaderPrograms/DeferredShading/fp_PhongLocal.cg", "Deferred shading with Phong illumination and point lights with local influence");
    return singleton;
}


//getPointer
DeferPhongLocal* DeferPhongLocal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* DeferPhongLocal::enableTraditional() {
    return TradPhongLocal::getPointer();
}
ShadingState* DeferPhongLocal::enableDeferred() {
    return singleton;
}
ShadingState* DeferPhongLocal::enableLocal() {
    return singleton;
}
ShadingState* DeferPhongLocal::enableSpot() {
    return DeferPhongSpot::getPointer();
}
ShadingState* DeferPhongLocal::enableGlobal() {
    return DeferPhongGlobal::getPointer();
}
ShadingState* DeferPhongLocal::enablePhong() {
    return singleton;
}
ShadingState* DeferPhongLocal::enableBlinnPhong() {
    return DeferBlinnPhongLocal::getPointer();
}
ShadingState* DeferPhongLocal::enableCookTorrance() {
    return DeferCookTorranceLocal::getPointer();
}
ShadingState* DeferPhongLocal::enableGooch() {
    return DeferGoochLocal::getPointer();
}
