#include <cstdlib>
#include "TradPhongSpot.h"
#include "DeferPhongLocal.h"
#include "DeferPhongGlobal.h"
#include "DeferBlinnPhongSpot.h"
#include "DeferCookTorranceSpot.h"
#include "DeferGoochSpot.h"
#include "DeferPhongSpot.h"


DeferPhongSpot* DeferPhongSpot::singleton = NULL;


//getInstance
DeferPhongSpot* DeferPhongSpot::getInstance(Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new DeferPhongSpot(geoLights, "Source/ShaderPrograms/DeferredShading/gp_Pyramid.cg", "Source/ShaderPrograms/DeferredShading/fp_PhongSpot.cg", "Deferred shading with Phong illumination and spot lights");
    return singleton;
}


//getPointer
DeferPhongSpot* DeferPhongSpot::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* DeferPhongSpot::enableTraditional() {
    return TradPhongSpot::getPointer();
}
ShadingState* DeferPhongSpot::enableDeferred() {
    return singleton;
}
ShadingState* DeferPhongSpot::enableLocal() {
    return DeferPhongLocal::getPointer();
}
ShadingState* DeferPhongSpot::enableSpot() {
    return singleton;
}
ShadingState* DeferPhongSpot::enableGlobal() {
    return DeferPhongGlobal::getPointer();
}
ShadingState* DeferPhongSpot::enablePhong() {
    return singleton;
}
ShadingState* DeferPhongSpot::enableBlinnPhong() {
    return DeferBlinnPhongSpot::getPointer();
}
ShadingState* DeferPhongSpot::enableCookTorrance() {
    return DeferCookTorranceSpot::getPointer();
}
ShadingState* DeferPhongSpot::enableGooch() {
    return DeferGoochSpot::getPointer();
}
