#ifndef FBO_H
#define FBO_H
/* Wrapper class for OpenGL's frame buffer object */


#include <GL/glew.h>


class Fbo {
	private:
		GLsizei fboWidth, fboHeight;
		GLuint fbo, depthBuffer;
        GLuint* textures;     //Attached textures
        GLenum* attachments;  //Attachment id's


	public:
		//Constructor. Create an FBO and a depth buffer with the specified width and height and attach texture(s) to FBO
		Fbo(GLsizei numAttachments, GLsizei fboWidth_, GLsizei fboHeight_);
        Fbo(GLsizei numAttachments, GLsizei fboWidth_, GLsizei fboHeight_, GLenum texType, GLenum minFilter, GLenum maxFilter, GLint internalFormat, GLenum format);

		//Destructor. Delete FBO and depth buffer
		~Fbo();

        //Get texture of specified attachment
        GLuint getTex(GLsizei attachment);

		//Bind the FBO and render to the attached textures
		void bind(GLsizei numAttachments);

		//Unbind the FBO, i.e. render to screen as usual
		void unbind();
};

#endif
