#include <cstdlib>
#include "Fbo.h"
#include "FboManager.h"


FboManager* FboManager::singleton = NULL;


//Constructor
FboManager::FboManager() {
    for(GLuint i = 0; i < 10; ++i)
        fbos[i] = NULL;
}


//getInstance
FboManager* FboManager::getInstance() {
    if (singleton == NULL)
        singleton = new FboManager();
    return singleton;
}


//createFbo
Fbo* FboManager::createFbo(GLuint index, GLsizei numAttachments, GLsizei fboWidth_, GLsizei fboHeight_) {
    if (fbos[index] == NULL)
        fbos[index] = new Fbo(numAttachments, fboWidth_, fboHeight_);
    return fbos[index];
}


//createFbo
Fbo* FboManager::createFbo(GLuint index, GLsizei numAttachments, GLsizei fboWidth_, GLsizei fboHeight_, GLenum texType, GLenum minFilter, GLenum maxFilter, GLint internalFormat, GLenum format) {
    if (fbos[index] == NULL)
        fbos[index] = new Fbo(numAttachments, fboWidth_, fboHeight_, texType, minFilter, maxFilter, internalFormat, format);
    return fbos[index];
}
