#ifndef FBO_MANAGER_H
#define FBO_MANAGER_H
/* Singleton. Manages Fbo's in case multiple objects want to use each other's Fbo */


class Fbo;


class FboManager {
    public:
        //Get a pointer to the FboManager singleton (and construct if this hasn't been done yet)
        static FboManager* getInstance();

        //Create Fbo at specified index. If an Fbo already exists at specified index, then return that one
        Fbo* createFbo(GLuint index, GLsizei numAttachments, GLsizei fboWidth_, GLsizei fboHeight_);
        Fbo* createFbo(GLuint index, GLsizei numAttachments, GLsizei fboWidth_, GLsizei fboHeight_, GLenum texType, GLenum minFilter, GLenum maxFilter, GLint internalFormat, GLenum format);


    private:
        static FboManager* singleton;
        Fbo* fbos[10];  //Maximum of 10 Fbo's


    private:
        //Constructor
        FboManager();

};

#endif
