#include <cstdlib>
#include "Geometry.h"
#include "FullScreenQuad.h"


FullScreenQuad* FullScreenQuad::singleton = NULL;


FullScreenQuad::FullScreenQuad() {
    GLuint indices[6]    = {0,1,2,  0,2,3};
    GLfloat positions[8] = {-1.0,-1.0,  1.0,-1.0,  1.0,1.0,  -1.0,1.0};
    GLfloat texCoords[8] = { 0.0,0.0,   1.0,0.0,   1.0,1.0,   0.0,1.0};
    geoQuad = new Geometry(4, 6);
    geoQuad->setPositions(XY, positions, GL_STATIC_DRAW);
    geoQuad->setTexCoords(XY, texCoords, GL_STATIC_DRAW);
    geoQuad->setIndices(GL_TRIANGLES, indices, GL_STATIC_DRAW);
}


//getInstance
FullScreenQuad* FullScreenQuad::getInstance() {
    if (singleton == NULL)
        singleton = new FullScreenQuad();
    return singleton;
}


//draw
void FullScreenQuad::draw() {
    geoQuad->draw();
}
