#ifndef FULL_SCREEN_QUAD_H
#define FULL_SCREEN_QUAD_H
/* Singleton. Quad with bottom-left coordinates (-1,-1,0) and upper-right coordinates (1,1,0). If coordinates are
   not transformed, it yields a full-screen quad */


class Geometry;


class FullScreenQuad {
    public:
        //Get a pointer to the FullScreenQuad singleton (and construct if this hasn't been done yet)
        static FullScreenQuad* getInstance();

        //Draw the quad
        void draw();


    private:
        static FullScreenQuad* singleton;
        Geometry* geoQuad;


    private:
        //Constructor
        FullScreenQuad();
};

#endif
