#include <GL/glew.h>
#include <GL/glut.h>
#include <iostream>
#include "Window.h"
#include "UserInterface.h"
#include "Demonstration.h"


UserInterface* userInterface;
Demonstration* demonstration;


// draw
void draw() {
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);  // Clear screen and depth buffer

    demonstration->draw();
    demonstration->timeStep();

    userInterface->drawInfo();

    glutSwapBuffers();
}


//main
int main(int argc, char** argv) {
    std::cout << "Loading...\n";

    //GLUT initialization
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    Window* window = Window::getInstance();
    //window->setWindow(1024, 768, 100, 100, "Deferred shading");
    window->setFullScreen();

    //GLEW initialization
    GLenum err = glewInit();
    if (GLEW_OK != err)    {
        std::cerr << "Failed to init GLEW. Exiting.\n";
        return -1;
    }

    //GLUT display
    glutDisplayFunc(draw);
    glutIdleFunc(draw);  //Also redraw our scene if there are no events

    //Initialize other things
    glClearColor(0.0, 0.0, 0.0, 1.0);  //Set the background color
    glClearDepth(1.0);                 //Set the clear value of the depth buffer
    glDepthFunc(GL_LEQUAL);            //Type of depth test to do
    glEnable(GL_DEPTH_TEST);           //Enable depth testing
    //glCullFace(GL_BACK);               //Cull back faces
    //glEnable(GL_CULL_FACE);            //Enable back-face culling

    demonstration = new Demonstration();
    userInterface = new UserInterface(demonstration);

    glutMainLoop();

    return 0;
}
