#ifndef SHADER_PROG_FACTORY_H
#define SHADER_PROG_FACTORY_H
/* Factory and Singleton. Class that handles creating and loading of shader programs */


#include <string>
#include <Cg/cg.h>
#include <Cg/cgGL.h>


//Publicly available
#define VERTEX_PROGRAM   0
#define GEOMETRY_PROGRAM 1
#define FRAGMENT_PROGRAM 2
extern CGcontext cg_Context;
extern CGprofile vertexProfile, geometryProfile, fragmentProfile;


class ShaderProgFactory {
    public:
        CGprogram shaderProgram;


    public:
        //Get a pointer to the ShaderProgFactory singleton
        static ShaderProgFactory* getInstance();

        //Create, compile, and load a shader program
        CGprogram loadProgram(std::string fileName, std::string mainFunction, GLubyte programType);

        //Create shader program without compiling and loading it
        CGprogram createProgram(std::string fileName, std::string mainFunction, GLubyte programType);


    private:
        static ShaderProgFactory* singleton;


    private:
        //Constructor
        ShaderProgFactory();
};

#endif
