#include "Geometry.h"
//Traditional shading with point lights (local)
#include "TradPhongLocal.h"
#include "TradBlinnPhongLocal.h"
#include "TradCookTorranceLocal.h"
#include "TradGoochLocal.h"
//Traditional shading with spot lights
#include "TradPhongSpot.h"
#include "TradBlinnPhongSpot.h"
#include "TradCookTorranceSpot.h"
#include "TradGoochSpot.h"
//Traditional shading with point lights (global)
#include "TradPhongGlobal.h"
#include "TradBlinnPhongGlobal.h"
#include "TradCookTorranceGlobal.h"
#include "TradGoochGlobal.h"
//Deferred shading with point lights (local)
#include "DeferPhongLocal.h"
#include "DeferBlinnPhongLocal.h"
#include "DeferCookTorranceLocal.h"
#include "DeferGoochLocal.h"
//Deferred shading with spot lights
#include "DeferPhongSpot.h"
#include "DeferBlinnPhongSpot.h"
#include "DeferCookTorranceSpot.h"
#include "DeferGoochSpot.h"
//Deferred shading with point lights (global)
#include "DeferPhongGlobal.h"
#include "DeferBlinnPhongGlobal.h"
#include "DeferCookTorranceGlobal.h"
#include "DeferGoochGlobal.h"
#include "ShadingStateFactory.h"


ShadingStateFactory::ShadingStateFactory(GLushort maxLights, Geometry* geoLights) {
    //Traditional shading with point lights (local)
    tradPhongPoint          = TradPhongLocal::getInstance(maxLights, geoLights);
    tradBlinnPhongPoint     = TradBlinnPhongLocal::getInstance(maxLights, geoLights);
    tradCookTorrancePoint   = TradCookTorranceLocal::getInstance(maxLights, geoLights);
    tradGoochPoint          = TradGoochLocal::getInstance(maxLights, geoLights);
    //Traditional shading with spot lights
    tradPhongSpot           = TradPhongSpot::getInstance(maxLights, geoLights);
    tradBlinnPhongSpot      = TradBlinnPhongSpot::getInstance(maxLights, geoLights);
    tradCookTorranceSpot    = TradCookTorranceSpot::getInstance(maxLights, geoLights);
    tradGoochSpot           = TradGoochSpot::getInstance(maxLights, geoLights);
    //Traditional shading with point lights (global)
    tradPhongGlobal         = TradPhongGlobal::getInstance(maxLights, geoLights);
    tradBlinnPhongGlobal    = TradBlinnPhongGlobal::getInstance(maxLights, geoLights);
    tradCookTorranceGlobal  = TradCookTorranceGlobal::getInstance(maxLights, geoLights);
    tradGoochGlobal         = TradGoochGlobal::getInstance(maxLights, geoLights);
    //Deferred shading with point lights (local)
    deferPhongPoint         = DeferPhongLocal::getInstance(geoLights);
    deferBlinnPhongPoint    = DeferBlinnPhongLocal::getInstance(geoLights);
    deferCookTorrancePoint  = DeferCookTorranceLocal::getInstance(geoLights);
    deferGoochPoint         = DeferGoochLocal::getInstance(geoLights);
    //Deferred shading with spot lights
    deferPhongSpot          = DeferPhongSpot::getInstance(geoLights);
    deferBlinnPhongSpot     = DeferBlinnPhongSpot::getInstance(geoLights);
    deferCookTorranceSpot   = DeferCookTorranceSpot::getInstance(geoLights);
    deferGoochSpot          = DeferGoochSpot::getInstance(geoLights);
    //Deferred shading with point lights (global)
    deferPhongGlobal        = DeferPhongGlobal::getInstance(geoLights);
    deferBlinnPhongGlobal   = DeferBlinnPhongGlobal::getInstance(geoLights);
    deferCookTorranceGlobal = DeferCookTorranceGlobal::getInstance(geoLights);
    deferGoochGlobal        = DeferGoochGlobal::getInstance(geoLights);
}
