#ifndef SHADING_STATE_FACTORY_H
#define SHADING_STATE_FACTORY_H
/* Factory. Constructs all possible ShadingState objects. Use it to construct the objects as a pre-processing step */


class Geometry;
//Traditional shading with point lights (local)
class TradPhongLocal;
class TradBlinnPhongLocal;
class TradCookTorranceLocal;
class TradGoochLocal;
//Traditional shading with spot lights
class TradPhongSpot;
class TradBlinnPhongSpot;
class TradCookTorranceSpot;
class TradGoochSpot;
//Traditional shading with point lights (global)
class TradPhongGlobal;
class TradBlinnPhongGlobal;
class TradCookTorranceGlobal;
class TradGoochGlobal;
//Deferred shading with point lights (local)
class DeferPhongLocal;
class DeferBlinnPhongLocal;
class DeferCookTorranceLocal;
class DeferGoochLocal;
//Deferred shading with spot lights
class DeferPhongSpot;
class DeferBlinnPhongSpot;
class DeferCookTorranceSpot;
class DeferGoochSpot;
//Deferred shading with point lights (global)
class DeferPhongGlobal;
class DeferBlinnPhongGlobal;
class DeferCookTorranceGlobal;
class DeferGoochGlobal;


class ShadingStateFactory {
    public:
        //Traditional shading with point lights (local)
        TradPhongLocal* tradPhongPoint;
        TradBlinnPhongLocal* tradBlinnPhongPoint;
        TradCookTorranceLocal* tradCookTorrancePoint;
        TradGoochLocal* tradGoochPoint;
        //Traditional shading with spot lights
        TradPhongSpot* tradPhongSpot;
        TradBlinnPhongSpot* tradBlinnPhongSpot;
        TradCookTorranceSpot* tradCookTorranceSpot;
        TradGoochSpot* tradGoochSpot;
        //Traditional shading with point lights (global)
        TradPhongGlobal* tradPhongGlobal;
        TradBlinnPhongGlobal* tradBlinnPhongGlobal;
        TradCookTorranceGlobal* tradCookTorranceGlobal;
        TradGoochGlobal* tradGoochGlobal;
        //Deferred shading with point lights (local)
        DeferPhongLocal* deferPhongPoint;
        DeferBlinnPhongLocal* deferBlinnPhongPoint;
        DeferCookTorranceLocal* deferCookTorrancePoint;
        DeferGoochLocal* deferGoochPoint;
        //Deferred shading with spot lights
        DeferPhongSpot* deferPhongSpot;
        DeferBlinnPhongSpot* deferBlinnPhongSpot;
        DeferCookTorranceSpot* deferCookTorranceSpot;
        DeferGoochSpot* deferGoochSpot;
        //Deferred shading with point lights (global)
        DeferPhongGlobal* deferPhongGlobal;
        DeferBlinnPhongGlobal* deferBlinnPhongGlobal;
        DeferCookTorranceGlobal* deferCookTorranceGlobal;
        DeferGoochGlobal* deferGoochGlobal;


    public:
        //Constructor
        ShadingStateFactory(GLushort maxLights, Geometry* geoLights);
};

#endif
