#ifndef TIMER_H
#define TIMER_H
/* Singleton. Class for timings and frame rate */


#ifdef _WIN32
#    include <windows.h>
#endif


class Timer {
    public:
		double time;  //Elapsed time from the point of construction of Timer object
        float fps;


    public:
        //Get a pointer to the Timer singleton (and construct if this hasn't been done yet)
        static Timer* getInstance();

        //Update variable 'time'
        void updateTime();

        //Compute frame rate and update variable 'time'
        void computeFps();


    private:
        static Timer* singleton;
        int numFrames;             //Number of frames drawn during a time interval of 0.3 sec
#   ifdef _WIN32
        double tPrev;              //Time variable
        double s;                  //Time interval of hi-resolution timer
        LARGE_INTEGER countStart;  //Initialized when Timer object is constructed
#   else
        double tStart, tPrev;      //Time variables
#   endif


    private:
        //Constructor
        Timer();
};

#endif
