#include <cstdlib>
#include "DeferBlinnPhongGlobal.h"
#include "TradBlinnPhongLocal.h"
#include "TradBlinnPhongSpot.h"
#include "TradPhongGlobal.h"
#include "TradCookTorranceGlobal.h"
#include "TradGoochGlobal.h"
#include "TradBlinnPhongGlobal.h"


TradBlinnPhongGlobal* TradBlinnPhongGlobal::singleton = NULL;


//getInstance
TradBlinnPhongGlobal* TradBlinnPhongGlobal::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradBlinnPhongGlobal(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_BlinnPhongGlobal.cg", "Traditional shading with Blinn-Phong illumination and point lights with global influence");
    return singleton;
}


//getPointer
TradBlinnPhongGlobal* TradBlinnPhongGlobal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradBlinnPhongGlobal::enableTraditional() {
    return singleton;
}
ShadingState* TradBlinnPhongGlobal::enableDeferred() {
    return DeferBlinnPhongGlobal::getPointer();
}
ShadingState* TradBlinnPhongGlobal::enableLocal() {
    return TradBlinnPhongLocal::getPointer();;
}
ShadingState* TradBlinnPhongGlobal::enableSpot() {
    return TradBlinnPhongSpot::getPointer();
}
ShadingState* TradBlinnPhongGlobal::enableGlobal() {
    return singleton;
}
ShadingState* TradBlinnPhongGlobal::enablePhong() {
    return TradPhongGlobal::getPointer();
}
ShadingState* TradBlinnPhongGlobal::enableBlinnPhong() {
    return singleton;
}
ShadingState* TradBlinnPhongGlobal::enableCookTorrance() {
    return TradCookTorranceGlobal::getPointer();
}
ShadingState* TradBlinnPhongGlobal::enableGooch() {
    return TradGoochGlobal::getPointer();
}
