#include <cstdlib>
#include "DeferBlinnPhongLocal.h"
#include "TradBlinnPhongSpot.h"
#include "TradBlinnPhongGlobal.h"
#include "TradPhongLocal.h"
#include "TradCookTorranceLocal.h"
#include "TradGoochLocal.h"
#include "TradBlinnPhongLocal.h"


TradBlinnPhongLocal* TradBlinnPhongLocal::singleton = NULL;


//getInstance
TradBlinnPhongLocal* TradBlinnPhongLocal::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradBlinnPhongLocal(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_BlinnPhongLocal.cg", "Traditional shading with Blinn-Phong illumination and point lights with local influence");
    return singleton;
}


//getPointer
TradBlinnPhongLocal* TradBlinnPhongLocal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradBlinnPhongLocal::enableTraditional() {
    return singleton;
}
ShadingState* TradBlinnPhongLocal::enableDeferred() {
    return DeferBlinnPhongLocal::getPointer();
}
ShadingState* TradBlinnPhongLocal::enableLocal() {
    return singleton;
}
ShadingState* TradBlinnPhongLocal::enableSpot() {
    return TradBlinnPhongSpot::getPointer();
}
ShadingState* TradBlinnPhongLocal::enableGlobal() {
    return TradBlinnPhongGlobal::getPointer();
}
ShadingState* TradBlinnPhongLocal::enablePhong() {
    return TradPhongLocal::getPointer();
}
ShadingState* TradBlinnPhongLocal::enableBlinnPhong() {
    return singleton;
}
ShadingState* TradBlinnPhongLocal::enableCookTorrance() {
    return TradCookTorranceLocal::getPointer();
}
ShadingState* TradBlinnPhongLocal::enableGooch() {
    return TradGoochLocal::getPointer();
}
