#include <cstdlib>
#include "DeferBlinnPhongSpot.h"
#include "TradBlinnPhongLocal.h"
#include "TradBlinnPhongGlobal.h"
#include "TradPhongSpot.h"
#include "TradCookTorranceSpot.h"
#include "TradGoochSpot.h"
#include "TradBlinnPhongSpot.h"


TradBlinnPhongSpot* TradBlinnPhongSpot::singleton = NULL;


//getInstance
TradBlinnPhongSpot* TradBlinnPhongSpot::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradBlinnPhongSpot(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_BlinnPhongSpot.cg", "Traditional shading with Blinn-Phong illumination and spot lights");
    return singleton;
}


//getPointer
TradBlinnPhongSpot* TradBlinnPhongSpot::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradBlinnPhongSpot::enableTraditional() {
    return singleton;
}
ShadingState* TradBlinnPhongSpot::enableDeferred() {
    return DeferBlinnPhongSpot::getPointer();
}
ShadingState* TradBlinnPhongSpot::enableLocal() {
    return TradBlinnPhongLocal::getPointer();
}
ShadingState* TradBlinnPhongSpot::enableSpot() {
    return singleton;
}
ShadingState* TradBlinnPhongSpot::enableGlobal() {
    return TradBlinnPhongGlobal::getPointer();
}
ShadingState* TradBlinnPhongSpot::enablePhong() {
    return TradPhongSpot::getPointer();
}
ShadingState* TradBlinnPhongSpot::enableBlinnPhong() {
    return singleton;
}
ShadingState* TradBlinnPhongSpot::enableCookTorrance() {
    return TradCookTorranceSpot::getPointer();
}
ShadingState* TradBlinnPhongSpot::enableGooch() {
    return TradGoochSpot::getPointer();
}
