#include <cstdlib>
#include "DeferCookTorranceGlobal.h"
#include "TradCookTorranceLocal.h"
#include "TradCookTorranceSpot.h"
#include "TradPhongGlobal.h"
#include "TradBlinnPhongGlobal.h"
#include "TradGoochGlobal.h"
#include "TradCookTorranceGlobal.h"


TradCookTorranceGlobal* TradCookTorranceGlobal::singleton = NULL;


//getInstance
TradCookTorranceGlobal* TradCookTorranceGlobal::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradCookTorranceGlobal(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_CookTorranceGlobal.cg", "Traditional shading with Cook-Torrance illumination and point lights with global influence");
    return singleton;
}


//getPointer
TradCookTorranceGlobal* TradCookTorranceGlobal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradCookTorranceGlobal::enableTraditional() {
    return singleton;
}
ShadingState* TradCookTorranceGlobal::enableDeferred() {
    return DeferCookTorranceGlobal::getPointer();
}
ShadingState* TradCookTorranceGlobal::enableLocal() {
    return TradCookTorranceLocal::getPointer();
}
ShadingState* TradCookTorranceGlobal::enableSpot() {
    return TradCookTorranceSpot::getPointer();
}
ShadingState* TradCookTorranceGlobal::enableGlobal() {
    return singleton;
}
ShadingState* TradCookTorranceGlobal::enablePhong() {
    return TradPhongGlobal::getPointer();
}
ShadingState* TradCookTorranceGlobal::enableBlinnPhong() {
    return TradBlinnPhongGlobal::getPointer();
}
ShadingState* TradCookTorranceGlobal::enableCookTorrance() {
    return singleton;
}
ShadingState* TradCookTorranceGlobal::enableGooch() {
    return TradGoochGlobal::getPointer();
}
