#include <cstdlib>
#include "DeferCookTorranceLocal.h"
#include "TradCookTorranceSpot.h"
#include "TradCookTorranceGlobal.h"
#include "TradPhongLocal.h"
#include "TradBlinnPhongLocal.h"
#include "TradGoochLocal.h"
#include "TradCookTorranceLocal.h"


TradCookTorranceLocal* TradCookTorranceLocal::singleton = NULL;


//getInstance
TradCookTorranceLocal* TradCookTorranceLocal::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradCookTorranceLocal(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_CookTorranceLocal.cg", "Traditional shading with Cook-Torrance illumination and point lights with local influence");
    return singleton;
}


//getPointer
TradCookTorranceLocal* TradCookTorranceLocal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradCookTorranceLocal::enableTraditional() {
    return singleton;
}
ShadingState* TradCookTorranceLocal::enableDeferred() {
    return DeferCookTorranceLocal::getPointer();
}
ShadingState* TradCookTorranceLocal::enableLocal() {
    return singleton;
}
ShadingState* TradCookTorranceLocal::enableSpot() {
    return TradCookTorranceSpot::getPointer();
}
ShadingState* TradCookTorranceLocal::enableGlobal() {
    return TradCookTorranceGlobal::getPointer();
}
ShadingState* TradCookTorranceLocal::enablePhong() {
    return TradPhongLocal::getPointer();
}
ShadingState* TradCookTorranceLocal::enableBlinnPhong() {
    return TradBlinnPhongLocal::getPointer();
}
ShadingState* TradCookTorranceLocal::enableCookTorrance() {
    return singleton;
}
ShadingState* TradCookTorranceLocal::enableGooch() {
    return TradGoochLocal::getPointer();
}
