#include <cstdlib>
#include "DeferCookTorranceSpot.h"
#include "TradCookTorranceLocal.h"
#include "TradCookTorranceGlobal.h"
#include "TradPhongSpot.h"
#include "TradBlinnPhongSpot.h"
#include "TradGoochSpot.h"
#include "TradCookTorranceSpot.h"


TradCookTorranceSpot* TradCookTorranceSpot::singleton = NULL;


//getInstance
TradCookTorranceSpot* TradCookTorranceSpot::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradCookTorranceSpot(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_CookTorranceSpot.cg", "Traditional shading with Cook-Torrance illumination and spot lights");
    return singleton;
}


//getPointer
TradCookTorranceSpot* TradCookTorranceSpot::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradCookTorranceSpot::enableTraditional() {
    return singleton;
}
ShadingState* TradCookTorranceSpot::enableDeferred() {
    return DeferCookTorranceSpot::getPointer();
}
ShadingState* TradCookTorranceSpot::enableLocal() {
    return TradCookTorranceLocal::getPointer();
}
ShadingState* TradCookTorranceSpot::enableSpot() {
    return singleton;
}
ShadingState* TradCookTorranceSpot::enableGlobal() {
    return TradCookTorranceGlobal::getPointer();
}
ShadingState* TradCookTorranceSpot::enablePhong() {
    return TradPhongSpot::getPointer();
}
ShadingState* TradCookTorranceSpot::enableBlinnPhong() {
    return TradBlinnPhongSpot::getPointer();
}
ShadingState* TradCookTorranceSpot::enableCookTorrance() {
    return singleton;
}
ShadingState* TradCookTorranceSpot::enableGooch() {
    return TradGoochSpot::getPointer();
}
