#include <cstdlib>
#include "DeferGoochGlobal.h"
#include "TradGoochLocal.h"
#include "TradGoochSpot.h"
#include "TradPhongGlobal.h"
#include "TradBlinnPhongGlobal.h"
#include "TradCookTorranceGlobal.h"
#include "TradGoochGlobal.h"


TradGoochGlobal* TradGoochGlobal::singleton = NULL;


//getInstance
TradGoochGlobal* TradGoochGlobal::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradGoochGlobal(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_GoochGlobal.cg", "Traditional shading with Gooch illumination and point lights with global influence");
    return singleton;
}


//getPointer
TradGoochGlobal* TradGoochGlobal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradGoochGlobal::enableTraditional() {
    return singleton;
}
ShadingState* TradGoochGlobal::enableDeferred() {
    return DeferGoochGlobal::getPointer();
}
ShadingState* TradGoochGlobal::enableLocal() {
    return TradGoochLocal::getPointer();
}
ShadingState* TradGoochGlobal::enableSpot() {
    return TradGoochSpot::getPointer();
}
ShadingState* TradGoochGlobal::enableGlobal() {
    return singleton;
}
ShadingState* TradGoochGlobal::enablePhong() {
    return TradPhongGlobal::getPointer();
}
ShadingState* TradGoochGlobal::enableBlinnPhong() {
    return TradBlinnPhongGlobal::getPointer();
}
ShadingState* TradGoochGlobal::enableCookTorrance() {
    return TradCookTorranceGlobal::getPointer();
}
ShadingState* TradGoochGlobal::enableGooch() {
    return singleton;
}
