#include <cstdlib>
#include "DeferGoochLocal.h"
#include "TradGoochSpot.h"
#include "TradGoochGlobal.h"
#include "TradPhongLocal.h"
#include "TradBlinnPhongLocal.h"
#include "TradCookTorranceLocal.h"
#include "TradGoochLocal.h"


TradGoochLocal* TradGoochLocal::singleton = NULL;


//getInstance
TradGoochLocal* TradGoochLocal::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradGoochLocal(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_GoochLocal.cg", "Traditional shading with Gooch illumination and point lights with local influence");
    return singleton;
}


//getPointer
TradGoochLocal* TradGoochLocal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradGoochLocal::enableTraditional() {
    return singleton;
}
ShadingState* TradGoochLocal::enableDeferred() {
    return DeferGoochLocal::getPointer();
}
ShadingState* TradGoochLocal::enableLocal() {
    return singleton;
}
ShadingState* TradGoochLocal::enableSpot() {
    return TradGoochSpot::getPointer();
}
ShadingState* TradGoochLocal::enableGlobal() {
    return TradGoochGlobal::getPointer();
}
ShadingState* TradGoochLocal::enablePhong() {
    return TradPhongLocal::getPointer();
}
ShadingState* TradGoochLocal::enableBlinnPhong() {
    return TradBlinnPhongLocal::getPointer();
}
ShadingState* TradGoochLocal::enableCookTorrance() {
    return TradCookTorranceLocal::getPointer();
}
ShadingState* TradGoochLocal::enableGooch() {
    return singleton;
}
