#include <cstdlib>
#include "DeferGoochSpot.h"
#include "TradGoochLocal.h"
#include "TradGoochGlobal.h"
#include "TradPhongSpot.h"
#include "TradBlinnPhongSpot.h"
#include "TradCookTorranceSpot.h"
#include "TradGoochSpot.h"


TradGoochSpot* TradGoochSpot::singleton = NULL;


//getInstance
TradGoochSpot* TradGoochSpot::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradGoochSpot(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_GoochSpot.cg", "Traditional shading with Gooch illumination and spot lights");
    return singleton;
}


//getPointer
TradGoochSpot* TradGoochSpot::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradGoochSpot::enableTraditional() {
    return singleton;
}
ShadingState* TradGoochSpot::enableDeferred() {
    return DeferGoochSpot::getPointer();
}
ShadingState* TradGoochSpot::enableLocal() {
    return TradGoochLocal::getPointer();
}
ShadingState* TradGoochSpot::enableSpot() {
    return singleton;
}
ShadingState* TradGoochSpot::enableGlobal() {
    return TradGoochGlobal::getPointer();
}
ShadingState* TradGoochSpot::enablePhong() {
    return TradPhongSpot::getPointer();
}
ShadingState* TradGoochSpot::enableBlinnPhong() {
    return TradBlinnPhongSpot::getPointer();
}
ShadingState* TradGoochSpot::enableCookTorrance() {
    return TradCookTorranceSpot::getPointer();
}
ShadingState* TradGoochSpot::enableGooch() {
    return singleton;
}
