#include <cstdlib>
#include "DeferPhongGlobal.h"
#include "TradPhongLocal.h"
#include "TradPhongSpot.h"
#include "TradBlinnPhongGlobal.h"
#include "TradCookTorranceGlobal.h"
#include "TradGoochGlobal.h"
#include "TradPhongGlobal.h"


TradPhongGlobal* TradPhongGlobal::singleton = NULL;


//getInstance
TradPhongGlobal* TradPhongGlobal::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradPhongGlobal(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_PhongGlobal.cg", "Traditional shading with Phong illumination and point lights with global influence");
    return singleton;
}


//getPointer
TradPhongGlobal* TradPhongGlobal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradPhongGlobal::enableTraditional() {
    return singleton;
}
ShadingState* TradPhongGlobal::enableDeferred() {
    return DeferPhongGlobal::getPointer();
}
ShadingState* TradPhongGlobal::enableLocal() {
    return TradPhongLocal::getPointer();
}
ShadingState* TradPhongGlobal::enableSpot() {
    return TradPhongSpot::getPointer();
}
ShadingState* TradPhongGlobal::enableGlobal() {
    return singleton;
}
ShadingState* TradPhongGlobal::enablePhong() {
    return singleton;
}
ShadingState* TradPhongGlobal::enableBlinnPhong() {
    return TradBlinnPhongGlobal::getPointer();
}
ShadingState* TradPhongGlobal::enableCookTorrance() {
    return TradCookTorranceGlobal::getPointer();
}
ShadingState* TradPhongGlobal::enableGooch() {
    return TradGoochGlobal::getPointer();
}
