#include <cstdlib>
#include "DeferPhongLocal.h"
#include "TradPhongSpot.h"
#include "TradPhongGlobal.h"
#include "TradBlinnPhongLocal.h"
#include "TradCookTorranceLocal.h"
#include "TradGoochLocal.h"
#include "TradPhongLocal.h"


TradPhongLocal* TradPhongLocal::singleton = NULL;


//getInstance
TradPhongLocal* TradPhongLocal::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradPhongLocal(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_PhongLocal.cg", "Traditional shading with Phong illumination and point lights with local influence");
    return singleton;
}


//getPointer
TradPhongLocal* TradPhongLocal::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradPhongLocal::enableTraditional() {
    return singleton;
}
ShadingState* TradPhongLocal::enableDeferred() {
    return DeferPhongLocal::getPointer();
}
ShadingState* TradPhongLocal::enableLocal() {
    return singleton;
}
ShadingState* TradPhongLocal::enableSpot() {
    return TradPhongSpot::getPointer();
}
ShadingState* TradPhongLocal::enableGlobal() {
    return TradPhongGlobal::getPointer();
}
ShadingState* TradPhongLocal::enablePhong() {
    return singleton;
}
ShadingState* TradPhongLocal::enableBlinnPhong() {
    return TradBlinnPhongLocal::getPointer();
}
ShadingState* TradPhongLocal::enableCookTorrance() {
    return TradCookTorranceLocal::getPointer();
}
ShadingState* TradPhongLocal::enableGooch() {
    return TradGoochLocal::getPointer();
}
