#include <cstdlib>
#include "DeferPhongSpot.h"
#include "TradPhongLocal.h"
#include "TradPhongGlobal.h"
#include "TradBlinnPhongSpot.h"
#include "TradCookTorranceSpot.h"
#include "TradGoochSpot.h"
#include "TradPhongSpot.h"


TradPhongSpot* TradPhongSpot::singleton = NULL;


//getInstance
TradPhongSpot* TradPhongSpot::getInstance(GLushort maxLights, Geometry* geoLights) {
    if (singleton == NULL)
        singleton = new TradPhongSpot(maxLights, geoLights, "Source/ShaderPrograms/TraditionalShading/fp_PhongSpot.cg", "Traditional shading with Phong illumination and spot lights");
    return singleton;
}


//getPointer
TradPhongSpot* TradPhongSpot::getPointer() {
    return singleton;
}


//ShadingState functions for switching between states
ShadingState* TradPhongSpot::enableTraditional() {
    return singleton;
}
ShadingState* TradPhongSpot::enableDeferred() {
    return DeferPhongSpot::getPointer();
}
ShadingState* TradPhongSpot::enableLocal() {
    return TradPhongLocal::getPointer();
}
ShadingState* TradPhongSpot::enableSpot() {
    return singleton;
}
ShadingState* TradPhongSpot::enableGlobal() {
    return TradPhongGlobal::getPointer();
}
ShadingState* TradPhongSpot::enablePhong() {
    return singleton;
}
ShadingState* TradPhongSpot::enableBlinnPhong() {
    return TradBlinnPhongSpot::getPointer();
}
ShadingState* TradPhongSpot::enableCookTorrance() {
    return TradCookTorranceSpot::getPointer();
}
ShadingState* TradPhongSpot::enableGooch() {
    return TradGoochSpot::getPointer();
}
