#include <string>
#include <sstream>
#include <GL/glut.h>
#include "Window.h"


Window* Window::singleton = NULL;
static int winWidth, winHeight;


//reshapeWindow
void reshapeWindow(int winWidth_, int winHeight_) {
    if (winHeight_ == 0)  //Prevent a divide by zero if the new window is too small
        winHeight = 1;
    winWidth = winWidth_;
    winHeight = winHeight_;

    glViewport(0, 0, winWidth, winHeight);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(55.0, (GLfloat)winWidth/(GLfloat)winHeight, 1.0, 1000.0);

    glMatrixMode(GL_MODELVIEW);
    glutPostRedisplay();
}


//getInstance
Window* Window::getInstance() {
    if (singleton == NULL)
        singleton = new Window();
    return singleton;
}


//setWindow
void Window::setWindow(int winWidth_, int winHeight_, int xPos, int yPos, char const* winTitle) {
    winWidth = winWidth_;
    winHeight = winHeight_;
    glutInitWindowSize(winWidth, winHeight);
    glutInitWindowPosition(xPos, yPos);
    glutCreateWindow(winTitle);
    glutReshapeFunc(reshapeWindow);
}


//setFullScreen
void Window::setFullScreen() {
    //Window width and height fill entire screen
    winWidth = glutGet(GLUT_SCREEN_WIDTH);
    winHeight = glutGet(GLUT_SCREEN_HEIGHT);
    std::stringstream sstream;
    sstream << winWidth;
    sstream << "x" << winHeight << ":32";
    std::string gameModeString = sstream.str();
    glutGameModeString(gameModeString.c_str());
    glutEnterGameMode();
    glutReshapeFunc(reshapeWindow);
}


//Get functions
int Window::getWidth() {
    return winWidth;
}
int Window::getHeight() {
    return winHeight;
}
