#ifndef WINDOW_H
#define WINDOW_H
/* Singleton. Class for window creation and window modification */


#include <string>


class Window {
    public:
        //Get a pointer to the Window singleton (and construct if this hasn't been done yet)
        static Window* getInstance();

        //Windowed mode
        void setWindow(int winWidth_, int winHeight_, int xPos, int yPos, char const* winTitle);

        //Full screen mode
        void setFullScreen();

        //Get functions
        int getWidth();
        int getHeight();


    private:
        static Window* singleton;


    private:
        //Constructor
        Window() {}
};

#endif